From 1f6159d05c41257f2cd24c0b336b8bcb9e9cb216 Mon Sep 17 00:00:00 2001
From: Holger Hans Peter Freyther <zecke@selfish.org>
Date: Tue, 16 Dec 2008 01:26:34 +0100
Subject: [PATCH] Hook into the font drawing to get hold of the pango lyout..

Force WebKit to take the "complex" path. This means everything
will run through pango. Add a todo where we need to convert the
pango line into our glyph string and hook into cairo-freetype/freetype
to extract the glyph's and their advance...
---
 WebCore/platform/graphics/FontFastPath.cpp |    6 +++++-
 WebCore/platform/graphics/gtk/FontGtk.cpp  |    1 +
 2 files changed, 6 insertions(+), 1 deletions(-)

diff --git a/WebCore/platform/graphics/FontFastPath.cpp b/WebCore/platform/graphics/FontFastPath.cpp
index 635aba9..ec6fd8f 100644
--- a/WebCore/platform/graphics/FontFastPath.cpp
+++ b/WebCore/platform/graphics/FontFastPath.cpp
@@ -177,6 +177,10 @@ Font::CodePath Font::codePath()
 
 bool Font::canUseGlyphCache(const TextRun& run) const
 {
+    // Run everything through pango...
+    return false;
+
+#if 0
     switch (s_codePath) {
         case Auto:
             break;
@@ -231,7 +235,7 @@ bool Font::canUseGlyphCache(const TextRun& run) const
     }
 
     return true;
-
+#endif
 }
 
 void Font::drawSimpleText(GraphicsContext* context, const TextRun& run, const FloatPoint& point, int from, int to) const
diff --git a/WebCore/platform/graphics/gtk/FontGtk.cpp b/WebCore/platform/graphics/gtk/FontGtk.cpp
index 288ba91..e8e0342 100644
--- a/WebCore/platform/graphics/gtk/FontGtk.cpp
+++ b/WebCore/platform/graphics/gtk/FontGtk.cpp
@@ -183,6 +183,7 @@ static void setPangoAttributes(const Font* font, const TextRun& run, PangoLayout
     pango_attr_list_unref(list);
 }
 
+// We will have to extract the glyph's here...
 void Font::drawComplexText(GraphicsContext* context, const TextRun& run, const FloatPoint& point, int from, int to) const
 {
     cairo_t* cr = context->platformContext();
-- 
1.5.6.3

